Unit DE00R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AME2R_p, DE04RQ_p, DE00RS_p, UTDE20_p;

procedure DE00R(F :Proc_F_DE; FJ :Proc_F_DE; M :Integer;
                var JSTART :Integer; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var A :Array of Real; var E1 :Array of Real;
                var E2 :Array of Real; var E3 :Array of Real;
                var E4 :Array of Real; var R :Array of Real;
                var R0 :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var YD :Array of Real; var IERR :Integer);
implementation

procedure DE00R(F :Proc_F_DE; FJ :Proc_F_DE; M :Integer;
                var JSTART :Integer; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var A :Array of Real; var E1 :Array of Real;
                var E2 :Array of Real; var E3 :Array of Real;
                var E4 :Array of Real; var R :Array of Real;
                var R0 :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var YD :Array of Real; var IERR :Integer);
var
I,J :Integer;
C1,EPS1 :Real;
BULD,BULEX,BULHM :Boolean;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180;
begin
IERR  := 0;
EPS1  := EPS/32.;
BULD  := True;
BULHM  := False;
BULEX  := False;
if ( JSTART ) < 0
 then goto _50
 else if ( JSTART ) > 0
       then goto _10
       else goto _70;
_10:
if ( JSTART  = 1 )
 then goto _100;
if ( JSTART  = 2 )
 then goto _20;
goto _80;
_20:
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    E1[(I-1)+(J-1)*M] := E2[(I-1)+(J-1)*M];
_30:
   end;
_40:
 end;
goto _90;
_50:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_60:
 end;
X  := XP;
_70:
FJ(X,YX,A,M);
_80:
C1  := H/4.;
AME2R(A,C1,M,E1,R,E3,E4);
if ( BULEX )
 then goto _100;
_90:
DE04RQ(M,E1,E2);
_100:
C1  := H/2.;
DE00RS(F,M,X,YX,H,A,E2,YD,R1,R2,R3);
DE00RS(F,M,X,YX,C1,A,E1,R0,R1,R2,R3);
DE00RS(F,M,X + C1,R0,C1,A,E1,R,R1,R2,R3);
for I:=1 to M do
 begin
  R1[I-1] := (R[I-1] - YD[I-1])/15.;
  C1  := Abs(R1[I-1]);
  if ( Abs(R[I-1]) >= P )
   then C1  := C1/Abs(R[I-1]);
  if ( C1  > EPS1 )
   then BULD  := False;
  if ( C1  >= EPS )
   then goto _140;
_110:
 end;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_120:
 end;
XP  := X;
for I:=1 to M do
 begin
  YX[I-1] := R[I-1];
_130:
 end;
X  := X + H;
if ( BULD )
 then H  := H*2.;
goto _180;
_140:
if ( BULHM )
 then goto _170;
H  := H/2.;
BUL  := False;
BULEX  := True;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    E2[(I-1)+(J-1)*M] := E1[(I-1)+(J-1)*M];
_150:
   end;
_160:
 end;
if ( Abs(H) > Abs(HMIN) )
 then goto _80;
H  := Sign(HMIN,H);
BULHM  := True;
BULEX  := False;
goto _80;
_170:
IERR  := 65;
UTDE20(IERR,0);
_180:
JSTART  := 1;
if ( BULD )
 then JSTART  := 2;
end;

end.
